Set release date for 2.9.5
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 # Enable colors in shelltest
24 SHELLTESTARGS = "-c"
25
26 ACLOCAL_AMFLAGS = -I autotools
27 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
28 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
29 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
30 CHECK_HEADER = $(top_srcdir)/autotools/check-header
31 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
32 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
33 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
34 CHECK_VERSION = $(top_srcdir)/autotools/check-version
35 CHECK_NEWS = $(top_srcdir)/autotools/check-news
36 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
37 DOCPP = $(top_srcdir)/autotools/docpp
38 REPLACE_VARS_SED = autotools/replace_vars.sed
39 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
40 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
41 SHELL_ENV_INIT = autotools/shell-env-init
42
43 # Note: these are automake-specific variables, and must be named after
44 # the directory + 'dir' suffix
45 clientdir = $(pkgpythondir)/client
46 cmdlibdir = $(pkgpythondir)/cmdlib
47 hypervisordir = $(pkgpythondir)/hypervisor
48 storagedir = $(pkgpythondir)/storage
49 httpdir = $(pkgpythondir)/http
50 masterddir = $(pkgpythondir)/masterd
51 confddir = $(pkgpythondir)/confd
52 rapidir = $(pkgpythondir)/rapi
53 serverdir = $(pkgpythondir)/server
54 watcherdir = $(pkgpythondir)/watcher
55 impexpddir = $(pkgpythondir)/impexpd
56 utilsdir = $(pkgpythondir)/utils
57 toolsdir = $(pkglibdir)/tools
58 iallocatorsdir = $(pkglibdir)/iallocators
59 pytoolsdir = $(pkgpythondir)/tools
60 docdir = $(datadir)/doc/$(PACKAGE)
61 myexeclibdir = $(pkglibdir)
62
63 # Delete output file if an error occurred while building it
64 .DELETE_ON_ERROR:
65
66 HS_DIRS = \
67         src \
68         src/Ganeti \
69         src/Ganeti/Confd \
70         src/Ganeti/Curl \
71         src/Ganeti/DataCollectors \
72         src/Ganeti/HTools \
73         src/Ganeti/HTools/Backend \
74         src/Ganeti/HTools/Program \
75         src/Ganeti/Hypervisor \
76         src/Ganeti/Hypervisor/Xen \
77         src/Ganeti/Monitoring \
78         src/Ganeti/Query \
79         src/Ganeti/Storage \
80         src/Ganeti/Storage/Diskstats \
81         src/Ganeti/Storage/Drbd \
82         src/Ganeti/Storage/Lvm \
83         test/hs \
84         test/hs/Test \
85         test/hs/Test/Ganeti \
86         test/hs/Test/Ganeti/Storage \
87         test/hs/Test/Ganeti/Storage/Diskstats \
88         test/hs/Test/Ganeti/Storage/Drbd \
89         test/hs/Test/Ganeti/Storage/Lvm \
90         test/hs/Test/Ganeti/Confd \
91         test/hs/Test/Ganeti/HTools \
92         test/hs/Test/Ganeti/HTools/Backend \
93         test/hs/Test/Ganeti/Hypervisor \
94         test/hs/Test/Ganeti/Hypervisor/Xen \
95         test/hs/Test/Ganeti/Query
96
97 # Haskell directories without the roots (src, test/hs)
98 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
99
100 DIRS = \
101         $(HS_DIRS) \
102         autotools \
103         daemons \
104         devel \
105         devel/data \
106         doc \
107         doc/css \
108         doc/examples \
109         doc/examples/gnt-debug \
110         doc/examples/hooks \
111         doc/users \
112         test/data/htools \
113         test/data/htools/rapi \
114         test/hs/shelltests \
115         test/autotools \
116         lib \
117         lib/build \
118         lib/client \
119         lib/cmdlib \
120         lib/confd \
121         lib/http \
122         lib/hypervisor \
123         lib/impexpd \
124         lib/masterd \
125         lib/rapi \
126         lib/server \
127         lib/storage \
128         lib/tools \
129         lib/utils \
130         lib/watcher \
131         man \
132         qa \
133         test \
134         test/data \
135         test/data/bdev-rbd \
136         test/data/ovfdata \
137         test/data/ovfdata/other \
138         test/py \
139         tools
140
141 ALL_APIDOC_HS_DIRS = \
142         $(APIDOC_HS_DIR) \
143         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
144
145 BUILDTIME_DIR_AUTOCREATE = \
146         scripts \
147         $(APIDOC_DIR) \
148         $(ALL_APIDOC_HS_DIRS) \
149         $(APIDOC_PY_DIR) \
150         $(COVERAGE_DIR) \
151         $(COVERAGE_HS_DIR) \
152         $(COVERAGE_PY_DIR) \
153         .hpc
154
155 BUILDTIME_DIRS = \
156         $(BUILDTIME_DIR_AUTOCREATE) \
157         doc/html \
158         doc/man-html
159
160 DIRCHECK_EXCLUDE = \
161         $(BUILDTIME_DIRS) \
162         ganeti-[0-9]*.[0-9]*.[0-9]* \
163         doc/html/_* \
164         doc/man-html/_* \
165         autom4te.cache
166
167 # some helper vars
168 COVERAGE_DIR = doc/coverage
169 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
170 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
171 APIDOC_DIR = doc/api
172 APIDOC_PY_DIR = $(APIDOC_DIR)/py
173 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
174
175 MAINTAINERCLEANFILES = \
176         $(maninput) \
177         doc/install-quick.rst \
178         doc/news.rst \
179         doc/upgrade.rst \
180         vcs-version
181
182 maintainer-clean-local:
183         rm -rf $(BUILDTIME_DIRS)
184
185 CLEANFILES = \
186         $(addsuffix /*.py[co],$(DIRS)) \
187         $(addsuffix /*.hi,$(HS_DIRS)) \
188         $(addsuffix /*.o,$(HS_DIRS)) \
189         $(PYTHON_BOOTSTRAP) \
190         epydoc.conf \
191         $(REPLACE_VARS_SED) \
192         $(SHELL_ENV_INIT) \
193         daemons/daemon-util \
194         daemons/ganeti-cleaner \
195         devel/squeeze-amd64.tar.gz \
196         devel/squeeze-amd64.conf \
197         $(mandocrst) \
198         doc/manpages-enabled.rst \
199         $(BUILT_EXAMPLES) \
200         doc/examples/bash_completion \
201         doc/examples/bash_completion-debug \
202         $(userspecs) \
203         lib/_generated_rpc.py \
204         $(man_MANS) \
205         $(manhtml) \
206         tools/kvm-ifup \
207         tools/vif-ganeti \
208         tools/net-common \
209         tools/users-setup \
210         tools/vcluster-setup \
211         stamp-directories \
212         stamp-srclinks \
213         $(nodist_pkgpython_PYTHON) \
214         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
215         $(HS_BUILT_TEST_HELPERS) \
216         src/ganeti-confd \
217         src/ganeti-luxid \
218         src/ganeti-mond \
219         .hpc/*.mix src/*.tix test/hs/*.tix \
220         doc/hs-lint.html
221
222 GENERATED_FILES = \
223         $(built_base_sources) \
224         $(BUILT_PYTHON_SOURCES) \
225         $(PYTHON_BOOTSTRAP)
226
227 HS_GENERATED_FILES =
228 if WANT_HTOOLS
229 HS_GENERATED_FILES += $(HS_PROGS)
230 if ENABLE_CONFD
231 HS_GENERATED_FILES += src/hconfd src/ganeti-confd src/hluxid src/ganeti-luxid
232 endif
233
234 if ENABLE_MOND
235 HS_GENERATED_FILES += src/ganeti-mond
236 endif
237 endif
238
239 built_base_sources = \
240         stamp-directories \
241         stamp-srclinks
242
243 built_python_base_sources = \
244         lib/_autoconf.py \
245         lib/_vcsversion.py
246
247 BUILT_PYTHON_SOURCES = \
248         $(built_python_base_sources) \
249         lib/_generated_rpc.py
250
251 # Generating the RPC wrappers depends on many things, so make sure
252 # it's built at the end of the built sources
253 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
254
255 # these are all built from the underlying %.in sources
256 BUILT_EXAMPLES = \
257         doc/examples/ganeti-kvm-poweroff.initd \
258         doc/examples/ganeti.cron \
259         doc/examples/ganeti.initd \
260         doc/examples/ganeti.logrotate \
261         doc/examples/ganeti-master-role.ocf \
262         doc/examples/ganeti-node-role.ocf \
263         doc/examples/gnt-config-backup \
264         doc/examples/hooks/ipsec
265
266 nodist_pkgpython_PYTHON = \
267         $(BUILT_PYTHON_SOURCES)
268
269 noinst_PYTHON = \
270         lib/build/__init__.py \
271         lib/build/shell_example_lexer.py \
272         lib/build/sphinx_ext.py
273
274 pkgpython_PYTHON = \
275         lib/__init__.py \
276         lib/asyncnotifier.py \
277         lib/backend.py \
278         lib/bootstrap.py \
279         lib/cli.py \
280         lib/compat.py \
281         lib/config.py \
282         lib/constants.py \
283         lib/daemon.py \
284         lib/errors.py \
285         lib/hooksmaster.py \
286         lib/ht.py \
287         lib/jqueue.py \
288         lib/jstore.py \
289         lib/locking.py \
290         lib/luxi.py \
291         lib/mcpu.py \
292         lib/netutils.py \
293         lib/objects.py \
294         lib/opcodes.py \
295         lib/outils.py \
296         lib/ovf.py \
297         lib/pathutils.py \
298         lib/qlang.py \
299         lib/query.py \
300         lib/rpc.py \
301         lib/rpc_defs.py \
302         lib/runtime.py \
303         lib/serializer.py \
304         lib/ssconf.py \
305         lib/ssh.py \
306         lib/uidpool.py \
307         lib/vcluster.py \
308         lib/network.py \
309         lib/workerpool.py
310
311 client_PYTHON = \
312         lib/client/__init__.py \
313         lib/client/gnt_backup.py \
314         lib/client/gnt_cluster.py \
315         lib/client/gnt_debug.py \
316         lib/client/gnt_group.py \
317         lib/client/gnt_instance.py \
318         lib/client/gnt_job.py \
319         lib/client/gnt_node.py \
320         lib/client/gnt_network.py \
321         lib/client/gnt_os.py \
322         lib/client/gnt_storage.py
323
324 cmdlib_PYTHON = \
325         lib/cmdlib/__init__.py \
326         lib/cmdlib/backup.py \
327         lib/cmdlib/base.py \
328         lib/cmdlib/cluster.py \
329         lib/cmdlib/common.py \
330         lib/cmdlib/group.py \
331         lib/cmdlib/instance.py \
332         lib/cmdlib/instance_migration.py \
333         lib/cmdlib/instance_operation.py \
334         lib/cmdlib/instance_query.py \
335         lib/cmdlib/instance_storage.py \
336         lib/cmdlib/instance_utils.py \
337         lib/cmdlib/misc.py \
338         lib/cmdlib/network.py \
339         lib/cmdlib/node.py \
340         lib/cmdlib/operating_system.py \
341         lib/cmdlib/query.py \
342         lib/cmdlib/tags.py \
343         lib/cmdlib/test.py
344
345 hypervisor_PYTHON = \
346         lib/hypervisor/__init__.py \
347         lib/hypervisor/hv_base.py \
348         lib/hypervisor/hv_chroot.py \
349         lib/hypervisor/hv_fake.py \
350         lib/hypervisor/hv_kvm.py \
351         lib/hypervisor/hv_lxc.py \
352         lib/hypervisor/hv_xen.py
353
354 storage_PYTHON = \
355         lib/storage/__init__.py \
356         lib/storage/bdev.py \
357         lib/storage/base.py \
358         lib/storage/container.py \
359         lib/storage/drbd.py \
360         lib/storage/drbd_info.py \
361         lib/storage/drbd_cmdgen.py \
362         lib/storage/filestorage.py
363
364 rapi_PYTHON = \
365         lib/rapi/__init__.py \
366         lib/rapi/baserlib.py \
367         lib/rapi/client.py \
368         lib/rapi/client_utils.py \
369         lib/rapi/connector.py \
370         lib/rapi/rlib2.py \
371         lib/rapi/testutils.py
372
373 http_PYTHON = \
374         lib/http/__init__.py \
375         lib/http/auth.py \
376         lib/http/client.py \
377         lib/http/server.py
378
379 confd_PYTHON = \
380         lib/confd/__init__.py \
381         lib/confd/client.py
382
383 masterd_PYTHON = \
384         lib/masterd/__init__.py \
385         lib/masterd/iallocator.py \
386         lib/masterd/instance.py
387
388 impexpd_PYTHON = \
389         lib/impexpd/__init__.py
390
391 watcher_PYTHON = \
392         lib/watcher/__init__.py \
393         lib/watcher/nodemaint.py \
394         lib/watcher/state.py
395
396 server_PYTHON = \
397         lib/server/__init__.py \
398         lib/server/masterd.py \
399         lib/server/noded.py \
400         lib/server/rapi.py
401
402 pytools_PYTHON = \
403         lib/tools/__init__.py \
404         lib/tools/burnin.py \
405         lib/tools/ensure_dirs.py \
406         lib/tools/node_cleanup.py \
407         lib/tools/node_daemon_setup.py \
408         lib/tools/prepare_node_join.py
409
410 utils_PYTHON = \
411         lib/utils/__init__.py \
412         lib/utils/algo.py \
413         lib/utils/filelock.py \
414         lib/utils/hash.py \
415         lib/utils/io.py \
416         lib/utils/log.py \
417         lib/utils/lvm.py \
418         lib/utils/mlock.py \
419         lib/utils/nodesetup.py \
420         lib/utils/process.py \
421         lib/utils/retry.py \
422         lib/utils/storage.py \
423         lib/utils/text.py \
424         lib/utils/wrapper.py \
425         lib/utils/x509.py
426
427 docinput = \
428         doc/conf.py \
429         doc/css/style.css \
430         doc/admin.rst \
431         doc/cluster-merge.rst \
432         doc/design-2.0.rst \
433         doc/design-2.1.rst \
434         doc/design-2.2.rst \
435         doc/design-2.3.rst \
436         doc/design-2.4.rst \
437         doc/design-2.5.rst \
438         doc/design-2.6.rst \
439         doc/design-2.7.rst \
440         doc/design-2.8.rst \
441         doc/design-2.9.rst \
442         doc/design-autorepair.rst \
443         doc/design-bulk-create.rst \
444         doc/design-chained-jobs.rst \
445         doc/design-cpu-pinning.rst \
446         doc/design-device-uuid-name.rst \
447         doc/design-draft.rst \
448         doc/design-glusterfs-ganeti-support.rst \
449         doc/design-daemons.rst \
450         doc/design-htools-2.3.rst \
451         doc/design-http-server.rst \
452         doc/design-impexp2.rst \
453         doc/design-internal-shutdown.rst \
454         doc/design-lu-generated-jobs.rst \
455         doc/design-linuxha.rst \
456         doc/design-multi-reloc.rst \
457         doc/design-network.rst \
458         doc/design-node-add.rst \
459         doc/design-oob.rst \
460         doc/design-openvswitch.rst \
461         doc/design-ovf-support.rst \
462         doc/design-opportunistic-locking.rst \
463         doc/design-partitioned.rst \
464         doc/design-query-splitting.rst \
465         doc/design-query2.rst \
466         doc/design-reason-trail.rst \
467         doc/design-resource-model.rst \
468         doc/design-restricted-commands.rst \
469         doc/design-shared-storage.rst \
470         doc/design-monitoring-agent.rst \
471         doc/design-virtual-clusters.rst \
472         doc/design-x509-ca.rst \
473         doc/design-hroller.rst \
474         doc/design-storagetypes.rst \
475         doc/devnotes.rst \
476         doc/glossary.rst \
477         doc/hooks.rst \
478         doc/iallocator.rst \
479         doc/index.rst \
480         doc/install-quick.rst \
481         doc/install.rst \
482         doc/locking.rst \
483         doc/manpages-disabled.rst \
484         doc/monitoring-query-format.rst \
485         doc/move-instance.rst \
486         doc/news.rst \
487         doc/ovfconverter.rst \
488         doc/rapi.rst \
489         doc/security.rst \
490         doc/upgrade.rst \
491         doc/virtual-cluster.rst \
492         doc/walkthrough.rst
493
494 # Generates file names such as "doc/man-gnt-instance.rst"
495 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
496
497 # Haskell programs to be installed in $PREFIX/bin
498 HS_BIN_PROGS=src/htools
499
500 # Haskell programs to be installed in the MYEXECLIB dir
501 if ENABLE_MOND
502 HS_MYEXECLIB_PROGS=src/mon-collector
503 else
504 HS_MYEXECLIB_PROGS=
505 endif
506
507 # Haskell programs to be compiled by "make really-all"
508 HS_COMPILE_PROGS= \
509         src/ganeti-mond \
510         src/hconfd \
511         src/hluxid \
512         src/rpc-test
513
514 # All Haskell non-test programs to be compiled but not automatically installed
515 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
516
517 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
518 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
519
520 HS_ALL_PROGS = \
521         $(HS_PROGS) \
522         test/hs/hpc-htools \
523         test/hs/hpc-mon-collector \
524         test/hs/htest \
525         $(HS_COMPILE_PROGS)
526
527 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
528 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
529
530 HFLAGS = \
531         -O -Wall -Werror -isrc \
532         -fwarn-monomorphism-restriction \
533         -fwarn-tabs \
534         $(GHC_BYVERSION_FLAGS)
535
536 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
537 HEXTRA =
538 # internal extra flags (used for test/hs/htest mainly)
539 HEXTRA_INT =
540 # exclude options for coverage reports
541 HPCEXCL = --exclude Main \
542         --exclude Ganeti.Constants \
543         --exclude Ganeti.HTools.QC \
544         --exclude Ganeti.THH \
545         --exclude Ganeti.Version \
546         --exclude Test.Ganeti.Attoparsec \
547         --exclude Test.Ganeti.TestCommon \
548         --exclude Test.Ganeti.TestHTools \
549         --exclude Test.Ganeti.TestHelper \
550         --exclude Test.Ganeti.TestImports \
551         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
552
553 HS_LIB_SRCS = \
554         src/Ganeti/BasicTypes.hs \
555         src/Ganeti/Common.hs \
556         src/Ganeti/Compat.hs \
557         src/Ganeti/Confd/Client.hs \
558         src/Ganeti/Confd/ClientFunctions.hs \
559         src/Ganeti/Confd/Server.hs \
560         src/Ganeti/Confd/Types.hs \
561         src/Ganeti/Confd/Utils.hs \
562         src/Ganeti/Config.hs \
563         src/Ganeti/ConfigReader.hs \
564         src/Ganeti/Curl/Multi.hs \
565         src/Ganeti/Daemon.hs \
566         src/Ganeti/DataCollectors/CLI.hs \
567         src/Ganeti/DataCollectors/Diskstats.hs \
568         src/Ganeti/DataCollectors/Drbd.hs \
569         src/Ganeti/DataCollectors/InstStatus.hs \
570         src/Ganeti/DataCollectors/InstStatusTypes.hs \
571         src/Ganeti/DataCollectors/Lv.hs \
572         src/Ganeti/DataCollectors/Program.hs \
573         src/Ganeti/DataCollectors/Types.hs \
574         src/Ganeti/Errors.hs \
575         src/Ganeti/HTools/Backend/IAlloc.hs \
576         src/Ganeti/HTools/Backend/Luxi.hs \
577         src/Ganeti/HTools/Backend/Rapi.hs \
578         src/Ganeti/HTools/Backend/Simu.hs \
579         src/Ganeti/HTools/Backend/Text.hs \
580         src/Ganeti/HTools/CLI.hs \
581         src/Ganeti/HTools/Cluster.hs \
582         src/Ganeti/HTools/Container.hs \
583         src/Ganeti/HTools/ExtLoader.hs \
584         src/Ganeti/HTools/Graph.hs \
585         src/Ganeti/HTools/Group.hs \
586         src/Ganeti/HTools/Instance.hs \
587         src/Ganeti/HTools/Loader.hs \
588         src/Ganeti/HTools/Nic.hs \
589         src/Ganeti/HTools/Node.hs \
590         src/Ganeti/HTools/PeerMap.hs \
591         src/Ganeti/HTools/Program/Hail.hs \
592         src/Ganeti/HTools/Program/Harep.hs \
593         src/Ganeti/HTools/Program/Hbal.hs \
594         src/Ganeti/HTools/Program/Hcheck.hs \
595         src/Ganeti/HTools/Program/Hinfo.hs \
596         src/Ganeti/HTools/Program/Hscan.hs \
597         src/Ganeti/HTools/Program/Hspace.hs \
598         src/Ganeti/HTools/Program/Hroller.hs \
599         src/Ganeti/HTools/Program/Main.hs \
600         src/Ganeti/HTools/Types.hs \
601         src/Ganeti/Hypervisor/Xen.hs \
602         src/Ganeti/Hypervisor/Xen/XmParser.hs \
603         src/Ganeti/Hypervisor/Xen/Types.hs \
604         src/Ganeti/Hash.hs \
605         src/Ganeti/JQueue.hs \
606         src/Ganeti/JSON.hs \
607         src/Ganeti/Jobs.hs \
608         src/Ganeti/Logging.hs \
609         src/Ganeti/Luxi.hs \
610         src/Ganeti/Monitoring/Server.hs \
611         src/Ganeti/Network.hs \
612         src/Ganeti/Objects.hs \
613         src/Ganeti/OpCodes.hs \
614         src/Ganeti/OpParams.hs \
615         src/Ganeti/Path.hs \
616         src/Ganeti/Query/Cluster.hs \
617         src/Ganeti/Query/Common.hs \
618         src/Ganeti/Query/Export.hs \
619         src/Ganeti/Query/Filter.hs \
620         src/Ganeti/Query/Group.hs \
621         src/Ganeti/Query/Job.hs \
622         src/Ganeti/Query/Language.hs \
623         src/Ganeti/Query/Network.hs \
624         src/Ganeti/Query/Node.hs \
625         src/Ganeti/Query/Query.hs \
626         src/Ganeti/Query/Server.hs \
627         src/Ganeti/Query/Types.hs \
628         src/Ganeti/Rpc.hs \
629         src/Ganeti/Runtime.hs \
630         src/Ganeti/Ssconf.hs \
631         src/Ganeti/Storage/Diskstats/Parser.hs \
632         src/Ganeti/Storage/Diskstats/Types.hs \
633         src/Ganeti/Storage/Drbd/Parser.hs \
634         src/Ganeti/Storage/Drbd/Types.hs \
635         src/Ganeti/Storage/Lvm/LVParser.hs \
636         src/Ganeti/Storage/Lvm/Types.hs \
637         src/Ganeti/Storage/Utils.hs \
638         src/Ganeti/THH.hs \
639         src/Ganeti/Types.hs \
640         src/Ganeti/Utils.hs
641
642 HS_TEST_SRCS = \
643         test/hs/Test/Ganeti/Attoparsec.hs \
644         test/hs/Test/Ganeti/BasicTypes.hs \
645         test/hs/Test/Ganeti/Common.hs \
646         test/hs/Test/Ganeti/Confd/Types.hs \
647         test/hs/Test/Ganeti/Confd/Utils.hs \
648         test/hs/Test/Ganeti/Daemon.hs \
649         test/hs/Test/Ganeti/Errors.hs \
650         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
651         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
652         test/hs/Test/Ganeti/HTools/CLI.hs \
653         test/hs/Test/Ganeti/HTools/Cluster.hs \
654         test/hs/Test/Ganeti/HTools/Container.hs \
655         test/hs/Test/Ganeti/HTools/Graph.hs \
656         test/hs/Test/Ganeti/HTools/Instance.hs \
657         test/hs/Test/Ganeti/HTools/Loader.hs \
658         test/hs/Test/Ganeti/HTools/Node.hs \
659         test/hs/Test/Ganeti/HTools/PeerMap.hs \
660         test/hs/Test/Ganeti/HTools/Types.hs \
661         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
662         test/hs/Test/Ganeti/JSON.hs \
663         test/hs/Test/Ganeti/Jobs.hs \
664         test/hs/Test/Ganeti/JQueue.hs \
665         test/hs/Test/Ganeti/Luxi.hs \
666         test/hs/Test/Ganeti/Network.hs \
667         test/hs/Test/Ganeti/Objects.hs \
668         test/hs/Test/Ganeti/OpCodes.hs \
669         test/hs/Test/Ganeti/Query/Filter.hs \
670         test/hs/Test/Ganeti/Query/Language.hs \
671         test/hs/Test/Ganeti/Query/Network.hs \
672         test/hs/Test/Ganeti/Query/Query.hs \
673         test/hs/Test/Ganeti/Rpc.hs \
674         test/hs/Test/Ganeti/Runtime.hs \
675         test/hs/Test/Ganeti/Ssconf.hs \
676         test/hs/Test/Ganeti/Storage/Diskstats/Parser.hs \
677         test/hs/Test/Ganeti/Storage/Drbd/Parser.hs \
678         test/hs/Test/Ganeti/Storage/Drbd/Types.hs \
679         test/hs/Test/Ganeti/Storage/Lvm/LVParser.hs \
680         test/hs/Test/Ganeti/THH.hs \
681         test/hs/Test/Ganeti/TestCommon.hs \
682         test/hs/Test/Ganeti/TestHTools.hs \
683         test/hs/Test/Ganeti/TestHelper.hs \
684         test/hs/Test/Ganeti/Types.hs \
685         test/hs/Test/Ganeti/Utils.hs
686
687 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
688
689 HS_BUILT_SRCS = \
690         test/hs/Test/Ganeti/TestImports.hs \
691         src/Ganeti/Constants.hs \
692         src/Ganeti/Curl/Internal.hs \
693         src/Ganeti/Version.hs
694 HS_BUILT_SRCS_IN = \
695         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
696         src/Ganeti/Curl/Internal.hsc
697
698 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
699
700 $(RUN_IN_TEMPDIR): | stamp-directories
701
702 doc/html/index.html: ENABLE_MANPAGES =
703 doc/man-html/index.html: ENABLE_MANPAGES = 1
704 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
705
706 # Note: we use here an order-only prerequisite, as the contents of
707 # _autoconf.py are not actually influencing the html build output: it
708 # has to exist in order for the sphinx module to be loaded
709 # successfully, but we certainly don't want the docs to be rebuilt if
710 # it changes
711 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
712         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
713         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
714         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
715         | $(BUILT_PYTHON_SOURCES)
716         @test -n "$(SPHINX)" || \
717             { echo 'sphinx-build' not found during configure; exit 1; }
718 if !MANPAGES_IN_DOC
719         if test -n '$(ENABLE_MANPAGES)'; then \
720           echo 'Man pages in documentation were disabled at configure time' >&2; \
721           exit 1; \
722         fi
723 endif
724 ## Sphinx provides little control over what content should be included. Some
725 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
726 ## build two different versions of the documentation--once without man pages and
727 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
728 ## us with this, but requires running in a temporary directory. It moves the
729 ## correct files into place depending on environment variables.
730         dir=$(dir $@) && \
731         @mkdir_p@ $$dir && \
732         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
733         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
734             -d . \
735             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
736             -D release="$(PACKAGE_VERSION)" \
737             -D graphviz_dot="$(DOT)" \
738             -D enable_manpages="$(ENABLE_MANPAGES)" \
739             doc $(CURDIR)/$$dir && \
740         rm -f $$dir/.buildinfo $$dir/objects.inv
741         touch $@
742
743 doc/html: doc/html/index.html
744
745 doc/man-html: doc/man-html/index.html
746
747 doc/install-quick.rst: INSTALL
748 doc/news.rst: NEWS
749 doc/upgrade.rst: UPGRADE
750
751 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
752         set -e; \
753         { echo '.. This file is automatically updated at build time from $<.'; \
754           echo '.. Do not edit.'; \
755           echo; \
756           cat $<; \
757         } > $@
758
759 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
760         { echo '.. This file is automatically generated, do not edit!'; \
761           echo ''; \
762           echo 'Man pages'; \
763           echo '========='; \
764           echo; \
765           echo '.. toctree::'; \
766           echo '   :maxdepth: 1'; \
767           echo; \
768           for i in $(notdir $(mandocrst)); do \
769             echo "   $$i"; \
770           done | LC_ALL=C sort; \
771         } > $@
772
773 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
774 if MANPAGES_IN_DOC
775         { echo '.. This file is automatically updated at build time from $<.'; \
776           echo '.. Do not edit.'; \
777           echo; \
778           echo "$*"; \
779           echo '=========================================='; \
780           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
781         } > $@
782 else
783         echo 'Man pages in documentation were disabled at configure time' >&2; \
784         exit 1;
785 endif
786
787 doc/users/%: doc/users/%.in Makefile $(REPLACE_VARS_SED)
788         cat $< | sed -f $(REPLACE_VARS_SED) | LC_ALL=C sort | uniq | (grep -v '^root' || true) > $@
789
790 userspecs = \
791         doc/users/users \
792         doc/users/groups \
793         doc/users/groupmemberships
794
795 # Things to build but not to install (add it to EXTRA_DIST if it should be
796 # distributed)
797 noinst_DATA = \
798         $(BUILT_EXAMPLES) \
799         doc/examples/bash_completion \
800         doc/examples/bash_completion-debug \
801         $(userspecs) \
802         $(manhtml)
803
804 if HAS_SPHINX
805 if MANPAGES_IN_DOC
806 noinst_DATA += doc/man-html
807 else
808 noinst_DATA += doc/html
809 endif
810 endif
811
812 gnt_scripts = \
813         scripts/gnt-backup \
814         scripts/gnt-cluster \
815         scripts/gnt-debug \
816         scripts/gnt-group \
817         scripts/gnt-instance \
818         scripts/gnt-job \
819         scripts/gnt-network \
820         scripts/gnt-node \
821         scripts/gnt-os \
822         scripts/gnt-storage
823
824 PYTHON_BOOTSTRAP_SBIN = \
825         daemons/ganeti-masterd \
826         daemons/ganeti-noded \
827         daemons/ganeti-rapi \
828         daemons/ganeti-watcher \
829         $(gnt_scripts)
830
831 PYTHON_BOOTSTRAP = \
832         $(PYTHON_BOOTSTRAP_SBIN) \
833         tools/burnin \
834         tools/ensure-dirs \
835         tools/node-cleanup \
836         tools/node-daemon-setup \
837         tools/prepare-node-join
838
839 qa_scripts = \
840         qa/__init__.py \
841         qa/ganeti-qa.py \
842         qa/qa_cluster.py \
843         qa/qa_config.py \
844         qa/qa_daemon.py \
845         qa/qa_env.py \
846         qa/qa_error.py \
847         qa/qa_group.py \
848         qa/qa_instance.py \
849         qa/qa_instance_utils.py \
850         qa/qa_job.py \
851         qa/qa_monitoring.py \
852         qa/qa_node.py \
853         qa/qa_os.py \
854         qa/qa_rapi.py \
855         qa/qa_tags.py \
856         qa/qa_utils.py
857
858 bin_SCRIPTS =
859 if WANT_HTOOLS
860 bin_SCRIPTS += $(HS_BIN_PROGS)
861 install-exec-hook:
862         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
863 # FIXME: this is a hardcoded logic, instead of auto-resolving
864         $(LN_S) -f ../../../bin/htools \
865           $(DESTDIR)$(iallocatorsdir)/hail
866         for role in $(HS_BIN_ROLES); do \
867           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
868         done
869 endif
870
871 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
872         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
873           echo "Error: cannot run unittests without the development" \
874                " libraries (see devnotes.rst)" 1>&2; \
875           exit 1; \
876         fi
877         @rm -f $(notdir $@).tix
878         $(GHC) --make \
879           $(HFLAGS) \
880           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
881           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
882           $(HEXTRA) $(HEXTRA_INT) $@
883         @touch "$@"
884
885 # for the test/hs/htest binary, we need to enable profiling/coverage
886 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
887
888 # we compile the hpc-htools binary with the program coverage
889 test/hs/hpc-htools: HEXTRA_INT=-fhpc
890
891 # we compile the hpc-mon-collector binary with the program coverage
892 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
893
894 # test dependency
895 test/hs/offline-test.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
896
897 # rules for building profiling-enabled versions of the haskell
898 # programs: hs-prof does the full two-step build, whereas
899 # hs-prof-quick does only the final rebuild (hs-prof must have been
900 # run before)
901 .PHONY: hs-prof hs-prof-quick
902 hs-prof:
903         @if [ -z "$(TARGET)" ]; then \
904           echo "You need to define TARGET when running this rule" 1>&2; \
905           exit 1; \
906         fi
907         $(MAKE) $(AM_MAKEFLAGS) clean
908         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
909         rm -f $(HS_ALL_PROGS)
910         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
911
912 hs-prof-quick:
913         @if [ -z "$(TARGET)" ]; then \
914           echo "You need to define TARGET when running this rule" 1>&2; \
915           exit 1; \
916         fi
917         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
918
919 dist_sbin_SCRIPTS = \
920         tools/ganeti-listrunner
921
922 nodist_sbin_SCRIPTS = \
923         $(PYTHON_BOOTSTRAP_SBIN) \
924         daemons/ganeti-cleaner
925
926 if ENABLE_CONFD
927 src/ganeti-confd: src/hconfd
928         cp -f $< $@
929
930 src/ganeti-luxid: src/hluxid
931         cp -f $< $@
932
933 nodist_sbin_SCRIPTS += src/ganeti-confd
934 nodist_sbin_SCRIPTS += src/ganeti-luxid
935 endif
936
937 if ENABLE_MOND
938 nodist_sbin_SCRIPTS += src/ganeti-mond
939 endif
940
941 python_scripts = \
942         tools/cfgshell \
943         tools/cfgupgrade \
944         tools/cfgupgrade12 \
945         tools/cluster-merge \
946         tools/confd-client \
947         tools/fmtjson \
948         tools/lvmstrap \
949         tools/move-instance \
950         tools/ovfconverter \
951         tools/sanitize-config
952
953 dist_tools_SCRIPTS = \
954         $(python_scripts) \
955         tools/burnin \
956         tools/kvm-console-wrapper \
957         tools/master-ip-setup \
958         tools/xen-console-wrapper
959
960 nodist_tools_python_scripts = \
961         tools/node-cleanup
962
963 nodist_tools_SCRIPTS = \
964         $(nodist_tools_python_scripts) \
965         tools/users-setup \
966         tools/vcluster-setup
967
968 pkglib_python_scripts = \
969         daemons/import-export \
970         tools/check-cert-expired
971
972 nodist_pkglib_python_scripts = \
973         tools/ensure-dirs \
974         tools/node-daemon-setup \
975         tools/prepare-node-join
976
977 myexeclib_SCRIPTS = \
978         daemons/daemon-util \
979         tools/kvm-ifup \
980         tools/vif-ganeti \
981         tools/net-common \
982         $(pkglib_python_scripts) \
983         $(HS_MYEXECLIB_PROGS)
984
985 nodist_myexeclib_SCRIPTS = \
986         $(nodist_pkglib_python_scripts)
987
988 EXTRA_DIST = \
989         NEWS \
990         UPGRADE \
991         epydoc.conf.in \
992         pylintrc \
993         autotools/build-bash-completion \
994         autotools/build-rpc \
995         autotools/check-header \
996         autotools/check-imports \
997         autotools/check-man-dashes \
998         autotools/check-man-references \
999         autotools/check-man-warnings \
1000         autotools/check-news \
1001         autotools/check-python-code \
1002         autotools/check-tar \
1003         autotools/check-version \
1004         autotools/convert-constants \
1005         autotools/docpp \
1006         autotools/gen-py-coverage \
1007         autotools/sphinx-wrapper \
1008         autotools/testrunner \
1009         autotools/wrong-hardcoded-paths \
1010         $(RUN_IN_TEMPDIR) \
1011         daemons/daemon-util.in \
1012         daemons/ganeti-cleaner.in \
1013         $(pkglib_python_scripts) \
1014         devel/upload \
1015         devel/webserver \
1016         tools/kvm-ifup.in \
1017         tools/vif-ganeti.in \
1018         tools/net-common.in \
1019         tools/vcluster-setup.in \
1020         $(docinput) \
1021         doc/html \
1022         $(BUILT_EXAMPLES:%=%.in) \
1023         doc/examples/ganeti.default \
1024         doc/examples/ganeti.default-debug \
1025         doc/examples/hooks/ethers \
1026         doc/examples/gnt-debug/README \
1027         doc/examples/gnt-debug/delay0.json \
1028         doc/examples/gnt-debug/delay50.json \
1029         doc/users/groupmemberships.in \
1030         doc/users/groups.in \
1031         doc/users/users.in \
1032         test/py/lockperf.py \
1033         test/py/testutils.py \
1034         test/py/mocks.py \
1035         $(dist_TESTS) \
1036         $(TEST_FILES) \
1037         man/footer.rst \
1038         $(manrst) \
1039         $(maninput) \
1040         qa/qa-sample.json \
1041         $(qa_scripts) \
1042         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
1043         $(HS_PROG_SRCS) \
1044         src/lint-hints.hs \
1045         test/hs/cli-tests-defs.sh \
1046         test/hs/offline-test.sh \
1047         .ghci
1048
1049 man_MANS = \
1050         man/ganeti-cleaner.8 \
1051         man/ganeti-confd.8 \
1052         man/ganeti-luxid.8 \
1053         man/ganeti-listrunner.8 \
1054         man/ganeti-masterd.8 \
1055         man/ganeti-mond.8 \
1056         man/ganeti-noded.8 \
1057         man/ganeti-os-interface.7 \
1058         man/ganeti-extstorage-interface.7 \
1059         man/ganeti-rapi.8 \
1060         man/ganeti-watcher.8 \
1061         man/ganeti.7 \
1062         man/gnt-backup.8 \
1063         man/gnt-cluster.8 \
1064         man/gnt-debug.8 \
1065         man/gnt-group.8 \
1066         man/gnt-network.8 \
1067         man/gnt-instance.8 \
1068         man/gnt-job.8 \
1069         man/gnt-node.8 \
1070         man/gnt-os.8 \
1071         man/gnt-storage.8 \
1072         man/hail.1 \
1073         man/harep.1 \
1074         man/hbal.1 \
1075         man/hcheck.1 \
1076         man/hinfo.1 \
1077         man/hscan.1 \
1078         man/hspace.1 \
1079         man/hroller.1 \
1080         man/htools.1 \
1081         man/mon-collector.7
1082
1083 # Remove extensions from all filenames in man_MANS
1084 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
1085
1086 manrst = $(patsubst %,%.rst,$(mannoext))
1087 manhtml = $(patsubst %.rst,%.html,$(manrst))
1088 mangen = $(patsubst %.rst,%.gen,$(manrst))
1089 maninput = \
1090         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
1091         $(patsubst %.html,%.html.in,$(manhtml)) \
1092         $(mangen)
1093
1094 TEST_FILES = \
1095         test/autotools/autotools-check-news.test \
1096         test/data/htools/clean-nonzero-score.data \
1097         test/data/htools/common-suffix.data \
1098         test/data/htools/empty-cluster.data \
1099         test/data/htools/hail-alloc-drbd.json \
1100         test/data/htools/hail-alloc-invalid-network.json \
1101         test/data/htools/hail-alloc-invalid-twodisks.json \
1102         test/data/htools/hail-alloc-restricted-network.json \
1103         test/data/htools/hail-alloc-spindles.json \
1104         test/data/htools/hail-alloc-twodisks.json \
1105         test/data/htools/hail-change-group.json \
1106         test/data/htools/hail-invalid-reloc.json \
1107         test/data/htools/hail-node-evac.json \
1108         test/data/htools/hail-reloc-drbd.json \
1109         test/data/htools/hbal-excl-tags.data \
1110         test/data/htools/hbal-split-insts.data \
1111         test/data/htools/hspace-tiered-dualspec-exclusive.data \
1112         test/data/htools/hspace-tiered-dualspec.data \
1113         test/data/htools/hspace-tiered-exclusive.data \
1114         test/data/htools/hspace-tiered-ipolicy.data \
1115         test/data/htools/hspace-tiered-mixed.data \
1116         test/data/htools/hspace-tiered-resourcetypes.data \
1117         test/data/htools/hspace-tiered-vcpu.data \
1118         test/data/htools/hspace-tiered.data \
1119         test/data/htools/invalid-node.data \
1120         test/data/htools/missing-resources.data \
1121         test/data/htools/multiple-master.data \
1122         test/data/htools/multiple-tags.data \
1123         test/data/htools/n1-failure.data \
1124         test/data/htools/rapi/groups.json \
1125         test/data/htools/rapi/info.json \
1126         test/data/htools/rapi/instances.json \
1127         test/data/htools/rapi/nodes.json \
1128         test/data/htools/hroller-full.data \
1129         test/data/htools/hroller-nodegroups.data \
1130         test/data/htools/hroller-nonredundant.data \
1131         test/data/htools/hroller-online.data \
1132         test/data/htools/unique-reboot-order.data \
1133         test/hs/shelltests/htools-balancing.test \
1134         test/hs/shelltests/htools-basic.test \
1135         test/hs/shelltests/htools-dynutil.test \
1136         test/hs/shelltests/htools-excl.test \
1137         test/hs/shelltests/htools-hail.test \
1138         test/hs/shelltests/htools-hroller.test \
1139         test/hs/shelltests/htools-hspace.test \
1140         test/hs/shelltests/htools-invalid.test \
1141         test/hs/shelltests/htools-multi-group.test \
1142         test/hs/shelltests/htools-no-backend.test \
1143         test/hs/shelltests/htools-rapi.test \
1144         test/hs/shelltests/htools-single-group.test \
1145         test/hs/shelltests/htools-text-backend.test \
1146         test/hs/shelltests/htools-mon-collector.test \
1147         test/data/bdev-drbd-8.0.txt \
1148         test/data/bdev-drbd-8.3.txt \
1149         test/data/bdev-drbd-8.4.txt \
1150         test/data/bdev-drbd-8.4-no-disk-params.txt \
1151         test/data/bdev-drbd-disk.txt \
1152         test/data/bdev-drbd-net-ip4.txt \
1153         test/data/bdev-drbd-net-ip6.txt \
1154         test/data/bdev-rbd/json_output_empty.txt \
1155         test/data/bdev-rbd/json_output_extra_matches.txt \
1156         test/data/bdev-rbd/json_output_no_matches.txt \
1157         test/data/bdev-rbd/json_output_ok.txt \
1158         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1159         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1160         test/data/bdev-rbd/plain_output_new_ok.txt \
1161         test/data/bdev-rbd/plain_output_old_empty.txt \
1162         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1163         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1164         test/data/bdev-rbd/plain_output_old_ok.txt \
1165         test/data/bdev-rbd/output_invalid.txt \
1166         test/data/cert1.pem \
1167         test/data/cert2.pem \
1168         test/data/cluster_config_2.7.json \
1169         test/data/cluster_config_2.8.json \
1170         test/data/cluster_config_2.9.json \
1171         test/data/instance-minor-pairing.txt \
1172         test/data/instance-prim-sec.txt \
1173         test/data/ip-addr-show-dummy0.txt \
1174         test/data/ip-addr-show-lo-ipv4.txt \
1175         test/data/ip-addr-show-lo-ipv6.txt \
1176         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1177         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1178         test/data/ip-addr-show-lo-oneline.txt \
1179         test/data/ip-addr-show-lo.txt \
1180         test/data/kvm_0.12.5_help.txt \
1181         test/data/kvm_0.15.90_help.txt \
1182         test/data/kvm_0.9.1_help.txt \
1183         test/data/kvm_0.9.1_help_boot_test.txt \
1184         test/data/kvm_1.0_help.txt \
1185         test/data/kvm_1.1.2_help.txt \
1186         test/data/lvs_lv.txt \
1187         test/data/NEWS_OK.txt \
1188         test/data/NEWS_previous_unreleased.txt \
1189         test/data/ovfdata/compr_disk.vmdk.gz \
1190         test/data/ovfdata/config.ini \
1191         test/data/ovfdata/corrupted_resources.ovf \
1192         test/data/ovfdata/empty.ini \
1193         test/data/ovfdata/empty.ovf \
1194         test/data/ovfdata/ganeti.mf \
1195         test/data/ovfdata/ganeti.ovf \
1196         test/data/ovfdata/gzip_disk.ovf \
1197         test/data/ovfdata/new_disk.vmdk \
1198         test/data/ovfdata/no_disk.ini \
1199         test/data/ovfdata/no_disk_in_ref.ovf \
1200         test/data/ovfdata/no_os.ini \
1201         test/data/ovfdata/no_ovf.ova \
1202         test/data/ovfdata/other/rawdisk.raw \
1203         test/data/ovfdata/ova.ova \
1204         test/data/ovfdata/rawdisk.raw \
1205         test/data/ovfdata/second_disk.vmdk \
1206         test/data/ovfdata/unsafe_path.ini \
1207         test/data/ovfdata/virtualbox.ovf \
1208         test/data/ovfdata/wrong_config.ini \
1209         test/data/ovfdata/wrong_extension.ovd \
1210         test/data/ovfdata/wrong_manifest.mf \
1211         test/data/ovfdata/wrong_manifest.ovf \
1212         test/data/ovfdata/wrong_ova.ova \
1213         test/data/ovfdata/wrong_xml.ovf \
1214         test/data/proc_diskstats.txt \
1215         test/data/proc_drbd8.txt \
1216         test/data/proc_drbd80-emptyline.txt \
1217         test/data/proc_drbd80-emptyversion.txt \
1218         test/data/proc_drbd83.txt \
1219         test/data/proc_drbd83_sync.txt \
1220         test/data/proc_drbd83_sync_want.txt \
1221         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1222         test/data/proc_drbd84.txt \
1223         test/data/proc_drbd84_sync.txt \
1224         test/data/proc_meminfo.txt \
1225         test/data/proc_cpuinfo.txt \
1226         test/data/qa-minimal-nodes-instances-only.json \
1227         test/data/sys_drbd_usermode_helper.txt \
1228         test/data/vgreduce-removemissing-2.02.02.txt \
1229         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1230         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1231         test/data/vgs-missing-pvs-2.02.02.txt \
1232         test/data/vgs-missing-pvs-2.02.66.txt \
1233         test/data/xen-xm-info-4.0.1.txt \
1234         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1235         test/data/xen-xm-list-4.0.1-four-instances.txt \
1236         test/data/xen-xm-list-long-4.0.1.txt \
1237         test/data/xen-xm-uptime-4.0.1.txt \
1238         test/py/ganeti-cli.test \
1239         test/py/gnt-cli.test \
1240         test/py/import-export_unittest-helper
1241
1242
1243 python_tests = \
1244         doc/examples/rapi_testutils.py \
1245         test/py/cfgupgrade_unittest.py \
1246         test/py/docs_unittest.py \
1247         test/py/ganeti.asyncnotifier_unittest.py \
1248         test/py/ganeti.backend_unittest-runasroot.py \
1249         test/py/ganeti.backend_unittest.py \
1250         test/py/ganeti.bootstrap_unittest.py \
1251         test/py/ganeti.cli_unittest.py \
1252         test/py/ganeti.client.gnt_cluster_unittest.py \
1253         test/py/ganeti.client.gnt_instance_unittest.py \
1254         test/py/ganeti.client.gnt_job_unittest.py \
1255         test/py/ganeti.cmdlib_unittest.py \
1256         test/py/ganeti.cmdlib.cluster_unittest.py \
1257         test/py/ganeti.cmdlib.instance_storage_unittest.py \
1258         test/py/ganeti.compat_unittest.py \
1259         test/py/ganeti.confd.client_unittest.py \
1260         test/py/ganeti.config_unittest.py \
1261         test/py/ganeti.constants_unittest.py \
1262         test/py/ganeti.daemon_unittest.py \
1263         test/py/ganeti.errors_unittest.py \
1264         test/py/ganeti.hooks_unittest.py \
1265         test/py/ganeti.ht_unittest.py \
1266         test/py/ganeti.http_unittest.py \
1267         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1268         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1269         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1270         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1271         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1272         test/py/ganeti.hypervisor_unittest.py \
1273         test/py/ganeti.impexpd_unittest.py \
1274         test/py/ganeti.jqueue_unittest.py \
1275         test/py/ganeti.jstore_unittest.py \
1276         test/py/ganeti.locking_unittest.py \
1277         test/py/ganeti.luxi_unittest.py \
1278         test/py/ganeti.masterd.iallocator_unittest.py \
1279         test/py/ganeti.masterd.instance_unittest.py \
1280         test/py/ganeti.mcpu_unittest.py \
1281         test/py/ganeti.netutils_unittest.py \
1282         test/py/ganeti.objects_unittest.py \
1283         test/py/ganeti.opcodes_unittest.py \
1284         test/py/ganeti.outils_unittest.py \
1285         test/py/ganeti.ovf_unittest.py \
1286         test/py/ganeti.qlang_unittest.py \
1287         test/py/ganeti.query_unittest.py \
1288         test/py/ganeti.rapi.baserlib_unittest.py \
1289         test/py/ganeti.rapi.client_unittest.py \
1290         test/py/ganeti.rapi.resources_unittest.py \
1291         test/py/ganeti.rapi.rlib2_unittest.py \
1292         test/py/ganeti.rapi.testutils_unittest.py \
1293         test/py/ganeti.rpc_unittest.py \
1294         test/py/ganeti.runtime_unittest.py \
1295         test/py/ganeti.serializer_unittest.py \
1296         test/py/ganeti.server.rapi_unittest.py \
1297         test/py/ganeti.ssconf_unittest.py \
1298         test/py/ganeti.ssh_unittest.py \
1299         test/py/ganeti.storage.bdev_unittest.py \
1300         test/py/ganeti.storage.container_unittest.py \
1301         test/py/ganeti.storage.drbd_unittest.py \
1302         test/py/ganeti.storage.filestorage_unittest.py \
1303         test/py/ganeti.tools.burnin_unittest.py \
1304         test/py/ganeti.tools.ensure_dirs_unittest.py \
1305         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1306         test/py/ganeti.tools.prepare_node_join_unittest.py \
1307         test/py/ganeti.uidpool_unittest.py \
1308         test/py/ganeti.utils.algo_unittest.py \
1309         test/py/ganeti.utils.filelock_unittest.py \
1310         test/py/ganeti.utils.hash_unittest.py \
1311         test/py/ganeti.utils.io_unittest-runasroot.py \
1312         test/py/ganeti.utils.io_unittest.py \
1313         test/py/ganeti.utils.log_unittest.py \
1314         test/py/ganeti.utils.lvm_unittest.py \
1315         test/py/ganeti.utils.mlock_unittest.py \
1316         test/py/ganeti.utils.nodesetup_unittest.py \
1317         test/py/ganeti.utils.process_unittest.py \
1318         test/py/ganeti.utils.retry_unittest.py \
1319         test/py/ganeti.utils.storage_unittest.py \
1320         test/py/ganeti.utils.text_unittest.py \
1321         test/py/ganeti.utils.wrapper_unittest.py \
1322         test/py/ganeti.utils.x509_unittest.py \
1323         test/py/ganeti.utils_unittest.py \
1324         test/py/ganeti.vcluster_unittest.py \
1325         test/py/ganeti.workerpool_unittest.py \
1326         test/py/pycurl_reset_unittest.py \
1327         test/py/qa.qa_config_unittest.py \
1328         test/py/tempfile_fork_unittest.py
1329
1330 haskell_tests = test/hs/htest
1331
1332 dist_TESTS = \
1333         test/py/check-cert-expired_unittest.bash \
1334         test/py/daemon-util_unittest.bash \
1335         test/py/ganeti-cleaner_unittest.bash \
1336         test/py/import-export_unittest.bash \
1337         test/py/cli-test.bash \
1338         test/py/bash_completion.bash
1339
1340 if PY_UNIT
1341 dist_TESTS += $(python_tests)
1342 endif
1343
1344 nodist_TESTS =
1345 check_SCRIPTS =
1346
1347 if WANT_HSTESTS
1348 nodist_TESTS += $(haskell_tests)
1349 dist_TESTS += test/hs/offline-test.sh
1350 check_SCRIPTS += \
1351         test/hs/hpc-htools \
1352         test/hs/hpc-mon-collector \
1353         $(HS_BUILT_TEST_HELPERS)
1354 endif
1355
1356 TESTS = $(dist_TESTS) $(nodist_TESTS)
1357
1358 # Environment for all tests
1359 PLAIN_TESTS_ENVIRONMENT = \
1360         PYTHONPATH=. \
1361         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1362         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1363         $(RUN_IN_TEMPDIR)
1364
1365 # Environment for tests run by automake
1366 TESTS_ENVIRONMENT = \
1367         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1368
1369 all_python_code = \
1370         $(dist_sbin_SCRIPTS) \
1371         $(python_scripts) \
1372         $(pkglib_python_scripts) \
1373         $(nodist_pkglib_python_scripts) \
1374         $(nodist_tools_python_scripts) \
1375         $(pkgpython_PYTHON) \
1376         $(client_PYTHON) \
1377         $(cmdlib_PYTHON) \
1378         $(hypervisor_PYTHON) \
1379         $(storage_PYTHON) \
1380         $(rapi_PYTHON) \
1381         $(server_PYTHON) \
1382         $(pytools_PYTHON) \
1383         $(http_PYTHON) \
1384         $(confd_PYTHON) \
1385         $(masterd_PYTHON) \
1386         $(impexpd_PYTHON) \
1387         $(utils_PYTHON) \
1388         $(watcher_PYTHON) \
1389         $(noinst_PYTHON) \
1390         $(qa_scripts)
1391
1392 if PY_UNIT
1393 all_python_code += $(python_tests)
1394 endif
1395
1396 srclink_files = \
1397         man/footer.rst \
1398         test/py/check-cert-expired_unittest.bash \
1399         test/py/daemon-util_unittest.bash \
1400         test/py/ganeti-cleaner_unittest.bash \
1401         test/py/import-export_unittest.bash \
1402         test/py/cli-test.bash \
1403         test/py/bash_completion.bash \
1404         test/hs/offline-test.sh \
1405         test/hs/cli-tests-defs.sh \
1406         $(all_python_code) \
1407         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1408         $(docinput)
1409
1410 check_python_code = \
1411         $(BUILD_BASH_COMPLETION) \
1412         $(CHECK_IMPORTS) \
1413         $(CHECK_HEADER) \
1414         $(DOCPP) \
1415         $(all_python_code)
1416
1417 lint_python_code = \
1418         ganeti \
1419         ganeti/http/server.py \
1420         $(dist_sbin_SCRIPTS) \
1421         $(python_scripts) \
1422         $(pkglib_python_scripts) \
1423         $(BUILD_BASH_COMPLETION) \
1424         $(CHECK_IMPORTS) \
1425         $(CHECK_HEADER) \
1426         $(DOCPP) \
1427         $(PYTHON_BOOTSTRAP)
1428
1429 standalone_python_modules = \
1430         lib/rapi/client.py \
1431         tools/ganeti-listrunner
1432
1433 pep8_python_code = \
1434         ganeti \
1435         ganeti/http/server.py \
1436         $(dist_sbin_SCRIPTS) \
1437         $(python_scripts) \
1438         $(pkglib_python_scripts) \
1439         $(BUILD_BASH_COMPLETION) \
1440         $(CHECK_HEADER) \
1441         $(DOCPP) \
1442         $(PYTHON_BOOTSTRAP) \
1443         qa
1444
1445 test/py/daemon-util_unittest.bash: daemons/daemon-util
1446
1447 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1448
1449 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1450
1451 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1452         sed -f $(REPLACE_VARS_SED) < $< > $@
1453         chmod +x $@
1454
1455 tools/vif-ganeti: tools/vif-ganeti.in $(REPLACE_VARS_SED)
1456         sed -f $(REPLACE_VARS_SED) < $< > $@
1457         chmod +x $@
1458
1459 tools/net-common: tools/net-common.in $(REPLACE_VARS_SED)
1460         sed -f $(REPLACE_VARS_SED) < $< > $@
1461         chmod +x $@
1462
1463 tools/users-setup: Makefile $(userspecs)
1464         set -e; \
1465         { echo '#!/bin/sh'; \
1466           echo 'if [ "x$$1" != "x--yes-do-it" ];'; \
1467           echo 'then echo "This will do the following changes"'; \
1468           $(AWK) -- '{print "echo + Will add group ",$$1; count++}\
1469                      END {if (count == 0) {print "echo + No groups to add"}}' doc/users/groups; \
1470           $(AWK) -- '{if (NF > 1) {print "echo + Will add user",$$1,"with primary group",$$2} \
1471                                   else {print "echo + Will add user",$$1}; count++}\
1472                      END {if (count == 0) {print "echo + No users to add"}}' doc/users/users; \
1473           $(AWK) -- '{print "echo + Will add user",$$1,"to group",$$2}' doc/users/groupmemberships; \
1474           echo 'echo'; \
1475           echo 'echo "OK? (y/n)"'; \
1476           echo 'read confirm'; \
1477           echo 'if [ "x$$confirm" != "xy" ]; then exit 0; fi'; \
1478           echo 'fi'; \
1479           $(AWK) -- '{print "addgroup --system",$$1}' doc/users/groups; \
1480           $(AWK) -- '{if (NF > 1) {print "adduser --system --ingroup",$$2,$$1} else {print "adduser --system",$$1}}' doc/users/users; \
1481           $(AWK) -- '{print "adduser",$$1,$$2}' doc/users/groupmemberships; \
1482         } > $@
1483         chmod +x $@
1484
1485 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1486         sed -f $(REPLACE_VARS_SED) < $< > $@
1487         chmod +x $@
1488
1489 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1490         sed -f $(REPLACE_VARS_SED) < $< > $@
1491         chmod +x $@
1492
1493 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1494         sed -f $(REPLACE_VARS_SED) < $< > $@
1495
1496 doc/examples/bash_completion: BC_ARGS = --compact
1497 doc/examples/bash_completion-debug: BC_ARGS =
1498
1499 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1500         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1501         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1502         daemons/ganeti-cleaner \
1503         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1504         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1505           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1506
1507 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1508         lib/build/shell_example_lexer.py \
1509         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1510         @echo "Checking $< for hardcoded paths..."
1511         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1512           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1513           exit 1; \
1514         fi
1515         set -e ; \
1516         trap 'echo auto-removing $@; rm $@' EXIT; \
1517         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1518         $(CHECK_MAN_REFERENCES) $@; \
1519         trap - EXIT
1520
1521 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1522         @test -n "$(PANDOC)" || \
1523           { echo 'pandoc' not found during configure; exit 1; }
1524         set -o pipefail -e; \
1525         trap 'echo auto-removing $@; rm $@' EXIT; \
1526         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1527           sed -e 's/\\@/@/g' > $@; \
1528         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1529         $(CHECK_MAN_DASHES) $@; \
1530         trap - EXIT
1531
1532 man/%.html.in: man/%.gen man/footer.rst
1533         @test -n "$(PANDOC)" || \
1534           { echo 'pandoc' not found during configure; exit 1; }
1535         set -o pipefail ; \
1536         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1537           sed -e 's/\\@/@/g' > $@
1538
1539 man/%: man/%.in  $(REPLACE_VARS_SED)
1540         sed -f $(REPLACE_VARS_SED) < $< > $@
1541
1542 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1543         sed -f $(REPLACE_VARS_SED) < $< > $@
1544
1545 vcs-version:
1546         if test -d .git; then \
1547           git describe > $@; \
1548         elif test ! -f $@ ; then \
1549           echo "Cannot auto-generate $@ file"; exit 1; \
1550         fi
1551
1552 .PHONY: clean-vcs-version
1553 clean-vcs-version:
1554         rm -f vcs-version
1555
1556 .PHONY: regen-vcs-version
1557 regen-vcs-version:
1558         @set -e; \
1559         cd $(srcdir); \
1560         if test -d .git; then \
1561           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1562           git describe > $$T; \
1563           if ! cmp --quiet $$T vcs-version; then \
1564             mv $$T vcs-version; \
1565           fi; \
1566         fi
1567
1568 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1569         vcs-version $(built_base_sources)
1570         set -e; \
1571         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1572         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1573
1574 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1575         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1576         lib/jstore.py $(RUN_IN_TEMPDIR) \
1577         $(CONVERT_CONSTANTS) $(built_base_sources) \
1578         | lib/_vcsversion.py
1579         set -e; \
1580         { cat $< ; \
1581           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1582         } > $@
1583
1584 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1585         hsc2hs -o $@ $<
1586
1587 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1588         $(built_base_sources)
1589         set -e; \
1590         { cat $< ; \
1591           echo ; \
1592           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1593             echo "import $$name ()" ; \
1594           done ; \
1595         } > $@
1596
1597 lib/_autoconf.py: Makefile | stamp-directories
1598         set -e; \
1599         { echo '# This file is automatically generated, do not edit!'; \
1600           echo '#'; \
1601           echo ''; \
1602           echo '"""Build-time configuration for Ganeti.'; \
1603           echo '';\
1604           echo 'This file is autogenerated by the build process.'; \
1605           echo 'For any changes you need to re-run ./configure (and'; \
1606           echo 'not edit by hand).'; \
1607           echo ''; \
1608           echo '"""'; \
1609           echo ''; \
1610           echo '# pylint: disable=C0301,C0324'; \
1611           echo '# because this is autogenerated, we do not want'; \
1612           echo '# style warnings' ; \
1613           echo ''; \
1614           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1615           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1616           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1617           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1618           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1619           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1620           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1621           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1622           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1623           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1624           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1625           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1626           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1627           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1628           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1629           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1630           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1631           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1632           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1633           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1634           echo "KVM_PATH = '$(KVM_PATH)'"; \
1635           echo "IP_PATH = '$(IP_PATH)'"; \
1636           echo "SOCAT_PATH = '$(SOCAT)'"; \
1637           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1638           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1639           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1640           echo "TOOLSDIR = '$(toolsdir)'"; \
1641           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1642           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1643           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1644           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1645           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1646           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1647           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1648           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1649           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1650           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1651           echo "RAPI_USER = '$(RAPI_USER)'"; \
1652           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1653           echo "CONFD_USER = '$(CONFD_USER)'"; \
1654           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1655           echo "LUXID_USER = '$(LUXID_USER)'"; \
1656           echo "LUXID_GROUP = '$(LUXID_GROUP)'"; \
1657           echo "NODED_USER = '$(NODED_USER)'"; \
1658           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1659           echo "MOND_USER = '$(MOND_USER)'"; \
1660           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1661           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1662           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1663           echo "HTOOLS = True"; \
1664           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1665           echo "XEN_CMD = '$(XEN_CMD)'"; \
1666           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1667           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1668           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1669 ## Write dictionary with man page name as the key and the section number as the
1670 ## value
1671           echo "MAN_PAGES = {"; \
1672           for i in $(notdir $(man_MANS)); do \
1673             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1674           done; \
1675           echo "}"; \
1676         } > $@
1677
1678 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1679         set -e; \
1680         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1681         { echo '# This file is automatically generated, do not edit!'; \
1682           echo '#'; \
1683           echo ''; \
1684           echo '"""Build-time VCS version number for Ganeti.'; \
1685           echo '';\
1686           echo 'This file is autogenerated by the build process.'; \
1687           echo 'For any changes you need to re-run ./configure (and'; \
1688           echo 'not edit by hand).'; \
1689           echo ''; \
1690           echo '"""'; \
1691           echo ''; \
1692           echo '# pylint: disable=C0301,C0324'; \
1693           echo '# because this is autogenerated, we do not want'; \
1694           echo '# style warnings' ; \
1695           echo ''; \
1696           echo "VCS_VERSION = '$$VCSVER'"; \
1697         } > $@
1698
1699 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1700         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1701
1702 $(SHELL_ENV_INIT): Makefile stamp-directories
1703         set -e; \
1704         { echo '# Allow overriding for tests'; \
1705           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1706           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1707           echo; \
1708           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1709           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1710           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1711           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1712           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1713         } > $@
1714
1715 ## Writes sed script to replace placeholders with build-time values. The
1716 ## additional quotes after the first @ sign are necessary to stop configure
1717 ## from replacing those values as well.
1718 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1719         set -e; \
1720         { echo 's#@''PREFIX@#$(prefix)#g'; \
1721           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1722           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1723           echo 's#@''BINDIR@#$(bindir)#g'; \
1724           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1725           echo 's#@''LIBDIR@#$(libdir)#g'; \
1726           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1727           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1728           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1729           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1730           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1731           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1732           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1733           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1734           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1735           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1736           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1737           echo 's#@''GNTLUXIDUSER@#$(LUXID_USER)#g'; \
1738           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1739           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1740           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1741           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1742           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1743           echo 's#@''GNTNODEDGROUP@#$(NODED_GROUP)#g'; \
1744           echo 's#@''GNTLUXIDGROUP@#$(LUXID_GROUP)#g'; \
1745           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1746           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1747           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1748           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1749           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1750           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1751           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1752           echo; \
1753           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1754           echo '  r $(SHELL_ENV_INIT)'; \
1755           echo '  d'; \
1756           echo '}'; \
1757         } > $@
1758
1759 # Using deferred evaluation
1760 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1761 daemons/ganeti-watcher: MODULE = ganeti.watcher
1762 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1763 tools/burnin: MODULE = ganeti.tools.burnin
1764 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1765 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1766 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1767 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1768 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1769
1770 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1771         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1772         set -e; \
1773         { echo '#!/usr/bin/python'; \
1774           echo '# This file is automatically generated, do not edit!'; \
1775           echo "# Edit $(MODULE) instead."; \
1776           echo; \
1777           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1778           echo; \
1779           echo '# pylint: disable=C0103'; \
1780           echo '# C0103: Invalid name'; \
1781           echo; \
1782           echo 'import sys'; \
1783           echo 'import $(MODULE) as main'; \
1784           echo; \
1785           echo '# Temporarily alias commands until bash completion'; \
1786           echo '# generator is changed'; \
1787           echo 'if hasattr(main, "commands"):'; \
1788           echo '  commands = main.commands # pylint: disable=E1101'; \
1789           echo 'if hasattr(main, "aliases"):'; \
1790           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1791           echo; \
1792           echo 'if __name__ == "__main__":'; \
1793           echo '  sys.exit(main.Main())'; \
1794         } > $@
1795         chmod u+x $@
1796
1797 $(HS_BUILT_TEST_HELPERS): Makefile
1798         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1799         set -e; \
1800         { echo '#!/bin/sh'; \
1801           echo '# This file is automatically generated, do not edit!'; \
1802           echo "# Edit Makefile.am instead."; \
1803           echo; \
1804           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1805         } > $@
1806         chmod u+x $@
1807
1808 stamp-directories: Makefile
1809         $(MAKE) $(AM_MAKEFLAGS) ganeti
1810         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1811         touch $@
1812
1813 # We need to create symlinks because "make distcheck" will not install Python
1814 # files when building.
1815 stamp-srclinks: Makefile | stamp-directories
1816         set -e; \
1817         for i in $(srclink_files); do \
1818           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1819             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1820           fi; \
1821         done
1822         touch $@
1823
1824 .PHONY: ganeti
1825 ganeti:
1826         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1827
1828 .PHONY: check-dirs
1829 check-dirs: $(GENERATED_FILES)
1830         @set -e; \
1831         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1832           error=; \
1833           while read dir; do \
1834             case "$$dir" in \
1835               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1836               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1837             esac; \
1838           done; \
1839           for dir in $(DIRS); do \
1840             if ! test -d "$$dir"; then \
1841               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1842               error=1; \
1843             fi \
1844           done; \
1845           test -z "$$error"; \
1846         }
1847
1848 .PHONY: check-local
1849 check-local: check-dirs $(GENERATED_FILES)
1850         $(CHECK_PYTHON_CODE) $(check_python_code)
1851         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1852         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1853         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
1854         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1855         error= ; \
1856         if [ "x`echo $(VERSION_SUFFIX)|grep 'alpha'`" == "x" ]; then \
1857           expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1858           if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1859             echo "Incorrect version in README, expected $$expver" >&2; \
1860             error=1; \
1861           fi; \
1862           for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1863               doc/security.rst; do \
1864             if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1865               "Documents Ganeti version $$expver"; then \
1866               echo "Incorrect version in $$file, expected $$expver" >&2; \
1867               error=1; \
1868             fi; \
1869           done; \
1870           if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1871             echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1872             error=1; \
1873           fi; \
1874           if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1875             ".. Last updated for Ganeti $$expver"; then \
1876             echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1877             error=1; \
1878           fi; \
1879         fi; \
1880         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1881           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1882             echo "Longest line in $$file is longer than 80 characters" >&2; \
1883             error=1; \
1884           fi; \
1885         done; \
1886         test -z "$$error"
1887
1888 .PHONY: hs-test-%
1889 hs-test-%: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1890         @rm -f htest.tix
1891         test/hs/htest -t $*
1892
1893 .PHONY: hs-tests
1894 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1895         @rm -f htest.tix
1896         ./test/hs/htest
1897
1898 .PHONY: hs-shell-%
1899 hs-shell-%: test/hs/hpc-htools test/hs/hpc-mon-collector \
1900             $(HS_BUILT_TEST_HELPERS)
1901         @rm -f hpc-htools.tix hpc-mon-collector.tix
1902         HBINARY="./test/hs/hpc-htools" \
1903         SHELLTESTARGS=$(SHELLTESTARGS) \
1904         ./test/hs/offline-test.sh $*
1905
1906 .PHONY: hs-shell
1907 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1908         @rm -f hpc-htools.tix hpc-mon-collector.tix
1909         HBINARY="./test/hs/hpc-htools" \
1910         SHELLTESTARGS=$(SHELLTESTARGS) \
1911         ./test/hs/offline-test.sh
1912
1913 .PHONY: hs-check
1914 hs-check: hs-tests hs-shell
1915
1916 # E111: indentation is not a multiple of four
1917 # E121: continuation line indentation is not a multiple of four
1918 #       (since our indent level is not 4)
1919 # E125: continuation line does not distinguish itself from next logical line
1920 #       (since our indent level is not 4)
1921 # E123: closing bracket does not match indentation of opening bracket's line
1922 # E127: continuation line over-indented for visual indent
1923 #       (since our indent level is not 4)
1924 # note: do NOT add E128 here; it's a valid style error in most cases!
1925 # I've seen real errors, but also some cases were we indent wrongly
1926 # due to line length; try to rework the cases where it is triggered,
1927 # instead of silencing it
1928 # E261: at least two spaces before inline comment
1929 # E501: line too long (80 characters)
1930 PEP8_IGNORE = E111,E121,E123,E125,E127,E261,E501
1931
1932 # For excluding pep8 expects filenames only, not whole paths
1933 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1934
1935 LINT_TARGETS = pylint pylint-qa
1936 if HAS_PEP8
1937 LINT_TARGETS += pep8
1938 endif
1939 if HAS_HLINT
1940 LINT_TARGETS += hlint
1941 endif
1942
1943 .PHONY: lint
1944 lint: $(LINT_TARGETS)
1945
1946 .PHONY: pylint
1947 pylint: $(GENERATED_FILES)
1948         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1949         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1950
1951 .PHONY: pylint-qa
1952 pylint-qa: $(GENERATED_FILES)
1953         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1954         cd $(top_srcdir)/qa && \
1955           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1956           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1957
1958 .PHONY: pep8
1959 pep8: $(GENERATED_FILES)
1960         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1961         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1962           --repeat $(pep8_python_code)
1963
1964 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1965 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1966 .PHONY: hlint
1967 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1968         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1969         @rm -f doc/hs-lint.html
1970         if tty -s; then C="-c"; else C=""; fi; \
1971         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1972           --ignore "Use first" \
1973           --ignore "Use &&&" \
1974           --ignore "Use void" \
1975           --ignore "Reduce duplication" \
1976           --hint src/lint-hints \
1977           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1978         @if [ ! -f doc/hs-lint.html ]; then \
1979           echo "All good" > doc/hs-lint.html; \
1980         fi
1981
1982 # a dist hook rule for updating the vcs-version file; this is
1983 # hardcoded due to where it needs to build the file...
1984 dist-hook:
1985         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1986         rm -f $(top_distdir)/vcs-version
1987         cp -p $(srcdir)/vcs-version $(top_distdir)
1988
1989 # a distcheck hook rule for catching revision control directories
1990 distcheck-hook:
1991         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1992           echo "Found revision control files in final archive." 1>&2; \
1993           exit 1; \
1994         fi
1995         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1996           echo "Found Python byte code in final archive." 1>&2; \
1997           exit 1; \
1998         fi
1999         if find $(top_distdir) -name '*~' | grep .; then \
2000           echo "Found backup files in final archive." 1>&2; \
2001           exit 1; \
2002         fi
2003 # Empty files or directories should not be distributed. They can cause
2004 # unnecessary warnings for packagers. Directories used by automake during
2005 # distcheck must be excluded.
2006         if find $(top_distdir) -empty -and -not \( \
2007             -path $(top_distdir)/_build -or \
2008             -path $(top_distdir)/_inst \) | grep .; then \
2009           echo "Found empty files or directories in final archive." 1>&2; \
2010           exit 1; \
2011         fi
2012         if test -e $(top_distdir)/doc/man-html; then \
2013           echo "Found documentation including man pages in final archive" >&2; \
2014           exit 1; \
2015         fi
2016
2017 # Backwards compatible distcheck-release target
2018 distcheck-release: distcheck
2019
2020 distrebuildcheck: dist
2021         set -e; \
2022         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
2023         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
2024         cd $$builddir; \
2025         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
2026         cd $(distdir); \
2027         ./configure; \
2028         $(MAKE) maintainer-clean; \
2029         cp $(abs_srcdir)/vcs-version .; \
2030         ./configure; \
2031         $(MAKE) $(AM_MAKEFLAGS)
2032
2033 dist-release: dist
2034         set -e; \
2035         for i in $(DIST_ARCHIVES); do \
2036           echo -n "Checking $$i ... "; \
2037           autotools/check-tar < $$i; \
2038           echo OK; \
2039         done
2040
2041 install-exec-local:
2042         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
2043           "$(DESTDIR)${localstatedir}/log/ganeti" \
2044           "$(DESTDIR)${localstatedir}/run/ganeti"
2045
2046 .PHONY: apidoc
2047 if WANT_HSAPIDOC
2048 apidoc: py-apidoc hs-apidoc
2049 else
2050 apidoc: py-apidoc
2051 endif
2052
2053 .PHONY: py-apidoc
2054 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
2055         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
2056         $(RUN_IN_TEMPDIR) epydoc -v \
2057           --conf $(CURDIR)/epydoc.conf \
2058           --output $(CURDIR)/$(APIDOC_PY_DIR)
2059
2060 .PHONY: hs-apidoc
2061 hs-apidoc: $(APIDOC_HS_DIR)/index.html
2062
2063 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
2064         @test -n "$(HSCOLOUR)" || \
2065             { echo 'HsColour' not found during configure; exit 1; }
2066         @test -n "$(HADDOCK)" || \
2067             { echo 'haddock' not found during configure; exit 1; }
2068         rm -rf $(APIDOC_HS_DIR)/*
2069         for i in $(ALL_APIDOC_HS_DIRS); do \
2070           @mkdir_p@ $$i; \
2071           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
2072         done
2073         set -e ; \
2074         export LC_ALL=en_US.UTF-8; \
2075         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
2076         if [ "$(HS_PARALLEL3)" ]; \
2077         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
2078         fi; \
2079         if [ "$(HS_REGEX_PCRE)" ]; \
2080         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
2081         fi; \
2082         for file in $(HS_LIBTESTBUILT_SRCS); do \
2083           f_nosrc=$${file##src/}; \
2084           f_notst=$${f_nosrc##test/hs/}; \
2085           f_html=$${f_notst%%.hs}.html; \
2086           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
2087         done ; \
2088         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
2089           -t ganeti -p src/haddock-prologue \
2090           --source-module="%{MODULE/.//}.html" \
2091           --source-entity="%{MODULE/.//}.html#%{NAME}" \
2092           $$OPTGHC \
2093           $(HS_LIBTESTBUILT_SRCS)
2094
2095 .PHONY: TAGS
2096 TAGS: $(GENERATED_FILES)
2097         rm -f TAGS
2098         $(GHC) -e ":etags" -v0 \
2099           $(filter-out -O -Werror,$(HFLAGS)) \
2100           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
2101           $(HS_LIBTEST_SRCS)
2102         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
2103           -path './daemons/ganeti-*' -o -path './tools/*' -o \
2104           -path './qa/*.py' | \
2105           etags -l python -a -
2106
2107 .PHONY: coverage
2108
2109 COVERAGE_TESTS=
2110 if WANT_HTOOLS
2111 COVERAGE_TESTS += hs-coverage
2112 endif
2113 if PY_UNIT
2114 COVERAGE_TESTS += py-coverage
2115 endif
2116
2117 coverage: $(COVERAGE_TESTS)
2118
2119 .PHONY: py-coverage
2120 py-coverage: $(GENERATED_FILES) $(python_tests)
2121         @test -n "$(PYCOVERAGE)" || \
2122             { echo 'python-coverage' not found during configure; exit 1; }
2123         set -e; \
2124         COVERAGE=$(PYCOVERAGE) \
2125         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
2126         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
2127         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
2128         $(PLAIN_TESTS_ENVIRONMENT) \
2129         $(abs_top_srcdir)/autotools/gen-py-coverage \
2130         $(python_tests)
2131
2132 .PHONY: hs-coverage
2133 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
2134         rm -f *.tix
2135         $(MAKE) $(AM_MAKEFLAGS) hs-check
2136         @mkdir_p@ $(COVERAGE_HS_DIR)
2137         hpc sum --union $(HPCEXCL) \
2138           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
2139         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
2140         hpc report coverage-hs.tix
2141         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
2142
2143 # Special "kind-of-QA" target for htools, needs special setup (all
2144 # tools compiled with -fhpc)
2145 .PHONY: live-test
2146 live-test: all
2147         set -e ; \
2148         cd src; \
2149         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
2150         rm -f *.tix *.mix; \
2151         ./live-test.sh; \
2152         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
2153           --output=live-test.tix ; \
2154         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
2155         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
2156           --srcdir=.. $(HPCEXCL) ; \
2157         hpc report --srcdir=.. live-test $(HPCEXCL)
2158
2159 commit-check: autotools-check distcheck lint apidoc
2160
2161 autotools-check:
2162         TESTDATA_DIR=./test/data shelltest $(SHELLTESTARGS) \
2163   $(abs_top_srcdir)/test/autotools/*-*.test \
2164   -- --hide-successes
2165
2166 .PHONY: gitignore-check
2167 gitignore-check:
2168         @if [ -n "`git status --short`" ]; then \
2169           echo "Git status is not clean!" 1>&2 ; \
2170           git status --short; \
2171           exit 1; \
2172         fi
2173
2174 # target to rebuild all man pages (both groff and html output)
2175 .PHONY: man
2176 man: $(man_MANS) $(manhtml)
2177
2178 # Target that builds all binaries (including those that are not
2179 # rebuilt except when running the tests)
2180 .PHONY: really-all
2181 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
2182
2183 # we don't need the ancient implicit rules:
2184 %: %,v
2185 %: RCS/%,v
2186 %: RCS/%
2187 %: s.%
2188 %: SCCS/s.%
2189
2190 -include ./Makefile.local
2191
2192 # vim: set noet :